/**
 *	PlasticStare PlasticWare Codebase Project (PWCB)
 *	This code is part of the PlasticStare PlasticWare codebase project. This work is Copyright (c) 2005 Ryan Todd, all rights reserved.
 *	Prior permission of the author is required in order to redistribute the source code or algorithms in a commercial product in any 
 *	form -- original or derivative, in any programming language. The source code of the equations may be distributed as part of a 
 *	non-commercial product, provided that redistributions contain the copyright notice:
 *
 *	This Code is Copyright (c) 2005 Ryan Todd, all rights reserved.
 *	This work is subject to the terms in http://www.plasticstare.com/plasticware/codebase_terms_of_use.html.
 *
 *	This code was created originally a few years ago for Flash MX and I decided to go ahead and release it again. 
 *	
 *
 *	Version :: v.1.5 "OLD" for Actionscript 1.0
*/ 
// These functions extend the capabilities for movieclips
// in flash for actionscript 1.0. They are a bit rough, and rather uncommented, but I have stopped
// using them for the most part, in favor of some AS 2.0 methodologies that I have developed...
// to use these, simply use the #include command in frame 1 of your movie...


secondsPerFrame = 1000/23; // where 23 is the framerate

// --------------------------------------
MovieClip.prototype.setPos = function (x,y) {
	this._x = x;
	this._y = y;
}
// --------------------------------------
MovieClip.prototype.hideMe = function () {
	this._alpha = 0;
	this._visible = 0;
}
// --------------------------------------
MovieClip.prototype.showMe = function () {
	this._alpha = 100;
	this._visible = true;
}
// --------------------------------------
MovieClip.prototype.fade = function(inOut, steps, kill) {
	this.theStepsTotal = steps;
	this.theSteps = steps;
	this.theInOut = inOut;
	this.killed = kill;
	if (this.fadeInterval >0) { //!= -1) {
		clearInterval(this.fadeInterval);
		this.fadeInterval = -1;
		this._alpha = 0;
	}
	if (inOut == "in") {
		this._alpha = 0;
		this._visible = true;
	}
	this.fadeInterval = setInterval(this, "fading", secondsPerFrame); };
// -----------------------------------------------------------------------
MovieClip.prototype.fading = function() {
	if (this.theSteps>=0) {
		if (this.theInOut == "out") {
			var newAlpha = (100/this.theStepsTotal)*this.theSteps;
			this._alpha = newAlpha;
		} else {
			var newAlpha = 100-((100/this.theStepsTotal)*this.theSteps);
			this._alpha = newAlpha;
		}
		this.theSteps--;
	} else {
		clearInterval(this.fadeInterval);
		this.fadeInterval = -1;
		if (this.theInOut == "out") {
			this._alpha = 0;
			if (this.killed) {
				this.hideMe();
			}
			//this._visible = this.killed;
		} else {
			this._alpha = 100;
		}
	}
};
// --------------------------------------
MovieClip.prototype.loadWithFade = function(picName, holderName) {
     // holderName can be passed in case needed for progress indicator
	// if not passed, use 'holder' as default
     var h1 = holderName==undefined ? "holder1" : holderName;
     this.createEmptyMovieClip(h1, 0);
     this.fadeHighLevel=1;
     this._visible = false;
     this[h1].loadMovie(picName);
     var id = setInterval(function (mc) {
		// width > 0 only when picture is completely loaded (and _width property available)
         if (mc[h1]._width > 0) {
             mc._alpha = 99;
             clearInterval(id);
             mc._visible = true;
             mc.onComplete();
				mc.fade("in",10);
         } else {
             mc.onLoading();
         }
     }, 80, this);
};
// --------------------------------------
MovieClip.prototype.crossFadeTo = function(picName,steps) {
	var h1 = "holder1";
	var h2 = "holder2"; 
	var totalsteps=23;
	if (steps!=undefined) {
		totalsteps=steps;
	}
	this.createEmptyMovieClip(h2,1);
	this[h2]._alpha=0;
	this[h2].loadMovie(picName);
	var id = setInterval(function (mc) {
		if (mc[h2]._width > 0) {
			mc._alpha = 100;
			clearInterval(id);
			mc._visible = true;
			mc.onComplete();
			mc.doCrossFade(h1,h2,totalsteps);
		} else {
			mc.onLoading();
    }
	}, 80, this);
}
// --------------------------------------
MovieClip.prototype.doCrossFade = function (mcOld,mcNew,steps) {
	this[mcNew].fade("in",steps);
	this[mcOld]._name = "swapped";
	this[mcNew].swapDepths(0);
	this[mcNew]._name = mcOld;
	this["swapped"].fade("out",steps,true);
	this["swapped"]._name = mcNew;
}
// --------------------------------------
// roundCoords - rounds the _x and _y properties of the movieclip
MovieClip.prototype.roundCoords = function () {
	this._x = Math.round(this._x);
	this._y = Math.round(this._y);
}
// --------------------------------------
// linearAnimate and linearAnimating....
// these functions allow for the linear animation of a movieclip
// only linearAnimate is ever called with the following parameters:
//		animationObject - describes the animation using an object as such:
//				{_x:2,_y:250} - this would animate the movieclip to (2,250)
//							OR using relative attributes (with +,-,*, or /)
//				{_x:"+40",_y:"-100"} - would move the clip 40px right and 100px up
//						(if relative, the attributes must be strings with the first
//						char being the operator for the operation performed)
//		timeOfMove - how long to make the animation happen
//		frameRateToUse - the "frame rate" in frames per second
MovieClip.prototype.linearAnimate = function(animationObject, timeOfMove, frameRateToUse) {
	this.linearAnimation = new Object();
	for (var i in animationObject) {
		if ((typeof (animationObject[i])) == "string") {
			var operator = animationObject[i].substr(0, 1);
			var operand = Number(animationObject[i].substr(1, animationObject[i].length-1));
			var result = this[i];
			switch (operator) {
			case "+" :
				result += operand;
				break;
			case "-" :
				result -= operand;
				break;
			case "*" :
				result *= operand;
				break;
			case "/" :
				result /= operand;
				break;
			}
			this.linearAnimation[i]=result;
		} else {
			this.linearAnimation[i] = animationObject[i];
		}
	}
	this.moveTime = (timeOfMove == undefined) ? 1 : timeOfMove;
	this.frameRate = (frameRateToUse == undefined) ? 23 : frameRateToUse;
	this.maxLASteps = this.frameRate*this.moveTime;
	this.curLASteps = 0;
	this.intTime = 1000/this.frameRate;
	if (this.LAInterval != -1) {
		clearInterval(this.LAInterval);
		this.LAInterval = -1;
	}
	this.LAInterval = setInterval(this, "linearAnimating", this.intTime);
};
// smalllinearAnimating moves the pages to their destination
MovieClip.prototype.linearAnimating = function() {
	this.curLASteps++;
	if (this.curLASteps>=this.maxLASteps) {
		for (var i in this.linearAnimation) {
			this[i] = this.linearAnimation[i];
		}
		clearInterval(this.LAInterval);
		this.LAInterval = -1;
	} else {
		for (var i in this.linearAnimation) {
			this[i] += ((this.linearAnimation[i]-this[i])/(this.maxLASteps-this.curLASteps));
		}
	}
};











